Kerbal Space Program - Bug #6504

Named saves fail to save.when overwriting
01/02/2016 11:21 AM - neuron

Status: Closed Start date: 01/02/2016
Severity: Low % Done: 100%
Assignee:

Category: Application

Target version:

Version: 1.0.5 Language: English (US)
Platform: Linux Mod Related: No
Expansion:

Description

Hi

I've played the game for about 60 hours now. My first game in career | played for 40+ hours, then | lost my savegame.

1. | saved (or atleast thought | did)

2. Loaded, realized the load had loaded a game which was very old and not the one | thought | saved.
3. Tried to load again, but realized | had no recent game and my persistant world was overwritten.

4. Immediately threw away the game and haven't touched it for 6 months.

(I have continous differential backups running, but since KSP saves everything in the steamapps directory it doesn't catch them. As
that directory has game files only for every other game..)

Now this happened again. | saved on "Save1", loaded, Save1 was definately not recent, and that overwrote my persistant world.
This has made me throw away the game after spending another 10+ hours on it, frankly this is the kind of bug that should never
never be possible. Anything leading up to it could be a user error (although | doubt it and | do think there is a bug in saving

somewhere..). BUT it's very easily solvable by autosaving the game and rotating the savegames. That should be minimal work.

I've been a software dev for about 15 years and | wouldn't generally mark a bug as critical in someone elses bugtracker, but this is in
my opinion the absolutely worst kind of bug possible... :/

Related issues:
Related to Kerbal Space Program - Bug #5354: Roles of Escape and Enter switch... Duplicate 08/28/2015

History

#1 - 01/02/2016 11:27 AM - neuron

(Note that in my recent "l saved on save1" there was already a savegame existing with that name. Maybe | wrote save1 and Save1 already existed
and that screws up on linux or something.. | dont know, it could be PEBCAK as well of course, but | just dont see how | screwed it up. Especially
twice).

#2 - 01/30/2016 12:30 AM - Skrudland

Exact same problem here. I've lost at least a week's worth of work three times now. Frustrating as hell.

After the first couple of times it happened | got into the habit of saving every time | did anything at all. Today | must have manually saved on my
"Skrud" savegame at least five times, and then when | try to load, it takes me way back in time. | checked the savegame folder in steamapps, and it's
saying my "Skrud" savegame was last modified ten days ago.

#3 - 02/21/2016 03:00 PM - Squelch
- Tracker changed from Bug to Feedback

- Severity changed from Critical to Low

Thank you for your report. However, it does not meet the requirements for a critical priority. Please read our Guide for details on how to report an
issue, and what the priorities mean.

As a developer, I'm sure you will appreciate the need for specifics when reporting a bug. These are sadly lacking here. Again, please refer to our
quide.
The expected behaviour, if I'm correct in interpreting the report, is that when saving a game, that this will automatically be loaded when resuming
again later?

The actual behaviour is thus:

A persistence file is created at the start of a game.

Auto saves are periodically written to persistence.

A change of scene (eg going from Tracking Station to flight) or other significant change to the game state will also write to persistence.
The persistence file is loaded when resuming a game.

A quicksave creates a snapshot.

Quicksaves are made pressing F5.

A second quicksave overwrites the existing quicksave.

Loading a quicksave is performed by pressing F9 for a few seconds.
Quick saves do not overwrite persistence file, but the next autosave will.
Quick saves are not auto loaded.

Named saves also create a snapshot.

These can be made from the KSC esc menu or by pressing mod+F5 key combination.

These saves can be named, and have a suggested name of quicksave + an increment (quicksave1 etc)

Loading a named save is performed using the mod+F9 key combination. Any save can be loaded from this menu, including the persistence file.
This can also be performed from the KSC esc menu.

Named saves do not overwrite the persistence file, but the next autosave will.

Named saves are not auto loaded.

The persistence file is not versioned or incremented. It is a record of the entire world state at the current time (persistence defined)
Quicksaves are unique snapshots of the persistence at a particular time. Loading them will roll back to that time. My understanding of the report is
that this is expected to be automatic.

It is unfortunate that you felt it necessary to throw games away, but the ability to preserve the game is available at any time, and furthermore can be
restored to that state at any time. The persistence file is the only file that is loaded when resuming a game.

It is conceded that the save mechanism is not well documented, nor particularly intuitive, so as a result | have changed this issue to feedback. The
alternative is to mark it as not a bug when the detailed explanation of the behaviour is considered.

Please be assured that steps are being made to improve the user experience of the save and load system.
[Addendum]
Case sensitivity is noted as having caused issues on Linux and OSX.

#4 - 02/21/2016 06:08 PM - Skrudland

| think you didn't quite understand what neuron and myself were saying. It's nothing to do with problems with the autosave, it's to do with the named
saves. I'm manually saving on a named save file, and then when | go to load said save file, it hasn't been saved and I've lost weeks of progress.

This is most definitely a bug.

#5 - 02/22/2016 10:52 AM - Squelch

Thanks for the clarification. The ambiguous description and especially the title "autosave" led to deceive. | will also admit to some confirmation bias on
my part as | was searching for savegame related issues, particularly around autosave user experience. Specifics would help greatly here.

My understanding now, is that a named save is not actually being saved, so the loading of another save is effectively leaving persistence in an
unwanted state?

A detailed recipe for reproduction would be most helpful in cases like this. If a named save is failing, then a copy of the logs would aid in identifying
why this would be.

If someone would be so kind as to provide further clarification and provide detailed steps for reproduction, we can look into this? A title change for this
issue is probably warranted once the nature of the problem is clear.

#6 - 02/22/2016 10:59 AM - neuron

Both times this has failed for me I've tried to save over an existing savegame. | haven't gotten an error or anything like that, but it just hasn't updated
the file. Therefor | assume everything is well, but So when | load the game again it's an ancient one.

This also overwrites the persistant world state, so | have no way to recover.
#7 - 02/22/2016 11:18 AM - Squelch
- Tracker changed from Feedback to Bug

- Subject changed from autosave to Named saves fail to save.when overwriting

- Status changed from New to Need More Info
neuron wrote:

Both times this has failed for me I've tried to save over an existing savegame. | haven't gotten an error or anything like that, but it just hasn't
updated the file. Therefor | assume everything is well, but So when | load the game again it's an ancient one.

This also overwrites the persistant world state, so | have no way to recover.

Thanks. The persistence will be updated, and this is by design. However, if a named save is not saving, then it is most certainly a bug.

A copy of the named save affected, together with copies of the logs that cover the attempt to overwrite can tell us a lot about what might be going
wrong. Does saving under a different name work correctly for that particular save? If so, please attach both the original and the new save? Again, logs
of the event are most useful.

Disregarding the autosave behaviour which sounds like it is working as designed, the failing to overwrite needs attention, but we really do need to get
an understanding on why this is happening under some circumstances.

#8 - 02/22/2016 11:43 AM - Squelch
- Related to Bug #5354: Roles of Escape and Enter switched in quicksave dialog added

#9 - 02/22/2016 11:44 AM - Squelch

| suspect that this might be a variation on the save dialog being dismissed when the "Enter" key is used. see issue #5354.

#10 - 02/22/2016 01:02 PM - Kasuha

| just tested it on my 1.0.5 KSP and | can confirm that overwriting named saves works for me.

Made a named save "Save1", tested that it loads

Switched to a different ship, made another named save "Save1", timestamp of the Save1.sfs updated and after | loaded it, | was on the second ship.
Then | switched to Space Center, made another named save "Save1" through the menu, again the file timestamp changed. Then | went to a ship,
loaded "Save1" through Alt+F9 and the game loaded it and switched me to an asteroid (#6337)

| used mouse to click on all buttons.

It should probably warn me when I'm overwriting an existing save though.

And it would be really great if the game gave me a list of already existing saves when | am creating a new one - either so | can avoid a nhame collision,

or so | can intentionally use the same name again, or so that | can simply create another one in a consistent manner, | like to make numbered named
saves: 00-launch, 01-orbit, 02-transfer burn, etc - but it's hard to remember last used number if | can't see them.

#11 - 02/23/2016 07:14 PM - Kasuha

Correction to my previous entry: I'm sorry, | did not notice the issue is about Linux. My test was on Windows, therefore not applicable to Linux issue.

#12 - 02/24/2016 08:43 PM - Skrudland

I'm having the same problem on Windows.

And it doesn't happen every time, just sometimes.

#13 - 07/17/2016 09:43 AM - TriggerAu

- Status changed from Need More Info to Needs Clarification

#14 - 10/13/2016 12:56 PM - sal_vager
- Status changed from Needs Clarification to Ready to Test

- % Done changed from 0 to 80

The actions of the enter and escape key are fixed now so this should no longer occur.

#15 - 11/18/2016 08:15 PM - JPLRepo
- Status changed from Ready to Test to Closed
- % Done changed from 80 to 100

Closing. No response.
